package jp.hishidama.win32.mshtml;

import jp.hishidama.win32.com.IDispatch;
import jp.hishidama.win32.com.IUnknown;
import jp.hishidama.win32.com.Variant;

/**
 * IHTMLAreasCollection,IHTMLAreasCollection2`3NX.
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.11.05
 * @see IHTMLMapElement#getAreas(boolean)
 */
public class IHTMLAreasCollection extends IDispatch {

	protected IHTMLAreasCollection(long dll_ptr) {
		super(dll_ptr);
	}

	public void setLength(int length) {
		Native.put_length(getPtr(), length);
	}

	public int getLength() {
		return Native.get_length(getPtr());
	}

	public IUnknown getNewEnum(boolean addChild) {
		IUnknown c = Native.get__newEnum(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public IDispatch item(Variant name, Variant index, boolean addChild) {
		IDispatch c = Native.item(getPtr(), name, index);
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public IDispatch tags(Variant tagName, boolean addChild) {
		IDispatch c = Native.tags(getPtr(), tagName);
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public void add(IHTMLElement element, Variant before) {
		Native.add(getPtr(), element.getPtr(), before);
	}

	public void remove(int index) {
		Native.remove(getPtr(), index);
	}

	public IDispatch urns(Variant urn, boolean addChild) {
		IDispatch c = Native.urns(getPtr(), urn);
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public IDispatch namedItem(String name, boolean addChild) {
		IDispatch c = Native.namedItem(getPtr(), name);
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	private static class Native {
		//
		// IHTMLAreasCollection
		//
		private static native void put_length(long ptr, int p);

		private static native int get_length(long ptr);

		private static native IUnknown get__newEnum(long ptr);

		private static native IDispatch item(long ptr, Variant name,
				Variant index);

		private static native IDispatch tags(long ptr, Variant tagName);

		private static native void add(long ptr, long element, Variant before);

		private static native void remove(long ptr, int index);

		//
		// IHTMLAreasCollection2
		//
		private static native IDispatch urns(long ptr, Variant urn);

		//
		// IHTMLAreasCollection3
		//
		private static native IDispatch namedItem(long ptr, String name);
	}
}
