package jp.hishidama.win32.mshtml;

import java.util.ArrayList;
import java.util.List;

import jp.hishidama.win32.com.ComPtr;
import jp.hishidama.win32.com.IDispatch;
import jp.hishidama.win32.com.IUnknown;
import jp.hishidama.win32.com.Variant;

/**
 * IHTMLElementCollection,IHTMLElementCollection2`3NX.
 * <p>
 * HTMLvf̈ꗗNXłB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.10.22
 * @version 2007.11.04
 */
public class IHTMLElementCollection extends IDispatch {

	protected IHTMLElementCollection(long dll_ptr) {
		super(dll_ptr);
	}

	/**
	 * ݒ.
	 * 
	 * @param len
	 *            
	 */
	public void setLength(int len) {
		Native.put_length(getPtr(), len);
	}

	/**
	 * 擾.
	 * 
	 * @return 
	 */
	public int getLength() {
		return Native.get_length(getPtr());
	}

	public IUnknown getNewEnum(boolean addChild) {
		IUnknown c = Native.get__newEnum(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param name
	 *            O
	 * @param index
	 *            ԍ
	 * @param addChild
	 *            trueFAj
	 * @return HTMLvf
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLElement item(String name, int index, boolean addChild) {
		IHTMLElement e = (IHTMLElement) Native.item(getPtr(),
				new Variant(name), new Variant(index));
		if (addChild) {
			addChildComPtr(e);
		}
		return e;
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param index
	 *            ԍ
	 * @param addChild
	 *            trueFAj
	 * @return HTMLvf
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLElement item(int index, boolean addChild) {
		Variant vari = new Variant(index);
		IHTMLElement e = (IHTMLElement) Native.item(getPtr(), vari, vari);
		if (addChild) {
			addChildComPtr(e);
		}
		return e;
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param tagName
	 *            ^O
	 * @param addChild
	 *            trueFAj
	 * @return HTMLvf
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLElement tags(Variant tagName, boolean addChild) {
		IHTMLElement e = (IHTMLElement) Native.tags(getPtr(), tagName);
		if (addChild) {
			addChildComPtr(e);
		}
		return e;
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param urn
	 *            URN
	 * @param addChild
	 *            trueFAj
	 * @return HTMLvf
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLElement urns(Variant urn, boolean addChild) {
		IHTMLElement e = (IHTMLElement) Native.urns(getPtr(), urn);
		if (addChild) {
			addChildComPtr(e);
		}
		return e;
	}

	/**
	 * HTMLvf擾.
	 * 
	 * @param name
	 *            
	 * @param addChild
	 *            trueFAj
	 * @return HTMLvf
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLElement getNamedItem(String name, boolean addChild) {
		IHTMLElement e = (IHTMLElement) Native.namedItem(getPtr(), name);
		if (addChild) {
			addChildComPtr(e);
		}
		return e;
	}

	/**
	 * Xg.
	 * <p>
	 * ێĂSvfXgɓĕԂB
	 * </p>
	 * 
	 * @param addChild
	 *            trueFAj
	 * @return {@link IHTMLElement}̃Xg
	 * @see ComPtr#disposeChild()
	 */
	public List list(boolean addChild) {
		long ptr = getPtr();
		int l = Native.get_length(ptr);
		List list = new ArrayList(l);
		Variant vari = new Variant();
		for (int i = 0; i < l; i++) {
			vari.setInt(i);
			IDispatch e = Native.item(ptr, vari, vari);
			if (addChild) {
				addChildComPtr(e);
			}
			list.add(e);
		}
		return list;
	}

	private static class Native {
		//
		// IHTMLElementCollection
		//

		// private static native String toString (long ptr);

		private static native void put_length(long ptr, int p);

		private static native int get_length(long ptr);

		private static native IUnknown get__newEnum(long ptr);

		private static native IDispatch item(long ptr, Variant name,
				Variant index);

		private static native IDispatch tags(long ptr, Variant tagName);

		//
		// IHTMLElementCollection2
		//

		private static native IDispatch urns(long ptr, Variant urn);

		//
		// IHTMLElementCollection3
		//

		private static native IDispatch namedItem(long ptr, String name);
	}
}
